uqmi: pass-through ipXtable to child interfaces
[openwrt/openwrt.git] / package / network / utils / uqmi / files / lib / netifd / proto / qmi.sh
index 9c953ea6975798caa69e04217ec9ae01ff9667c9..c60cae653a4296611b853c1d7f705c76895d2fcc 100755 (executable)
@@ -27,11 +27,12 @@ proto_qmi_init_config() {
 
 proto_qmi_setup() {
        local interface="$1"
-
+       local dataformat connstat
        local device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn $PROTO_DEFAULT_OPTIONS
+       local ip4table ip6table
        local cid_4 pdh_4 cid_6 pdh_6
        local ip_6 ip_prefix_length gateway_6 dns1_6 dns2_6
-       json_get_vars device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn $PROTO_DEFAULT_OPTIONS
+       json_get_vars device apn auth username password pincode delay modes pdptype profile dhcpv6 autoconnect plmn ip4table ip6table $PROTO_DEFAULT_OPTIONS
 
        [ "$metric" = "" ] && metric="0"
 
@@ -44,6 +45,8 @@ proto_qmi_setup() {
                return 1
        }
 
+       [ -n "$delay" ] && sleep "$delay"
+
        device="$(readlink -f $device)"
        [ -c "$device" ] || {
                echo "The specified control device does not exist"
@@ -62,15 +65,13 @@ proto_qmi_setup() {
                return 1
        }
 
-       [ -n "$delay" ] && sleep "$delay"
-
        while uqmi -s -d "$device" --get-pin-status | grep '"UIM uninitialized"' > /dev/null; do
                [ -e "$device" ] || return 1
                sleep 1;
        done
 
        [ -n "$pincode" ] && {
-               uqmi -s -d "$device" --verify-pin1 "$pincode" || uqmi -s -d "$device" --uim-verify-pin1 "$pincode" || {
+               uqmi -s -d "$device" --verify-pin1 "$pincode" > /dev/null || uqmi -s -d "$device" --uim-verify-pin1 "$pincode" > /dev/null || {
                        echo "Unable to verify PIN"
                        proto_notify_error "$interface" PIN_FAILED
                        proto_block_restart "$interface"
@@ -97,8 +98,25 @@ proto_qmi_setup() {
                }
        }
 
+       # Cleanup current state if any
+       uqmi -s -d "$device" --stop-network 0xffffffff --autoconnect
+
+       # Set IP format
        uqmi -s -d "$device" --set-data-format 802.3
        uqmi -s -d "$device" --wda-set-data-format 802.3
+       dataformat="$(uqmi -s -d "$device" --wda-get-data-format)"
+
+       if [ "$dataformat" = '"raw-ip"' ]; then
+
+               [ -f /sys/class/net/$ifname/qmi/raw_ip ] || {
+                       echo "Device only supports raw-ip mode but is missing this required driver attribute: /sys/class/net/$ifname/qmi/raw_ip"
+                       return 1
+               }
+
+               echo "Device does not support 802.3 mode. Informing driver of raw-ip only for $ifname .."
+               echo "Y" > /sys/class/net/$ifname/qmi/raw_ip
+       fi
+
        uqmi -s -d "$device" --sync
 
        echo "Waiting for network registration"
@@ -123,19 +141,14 @@ proto_qmi_setup() {
 
        [ "$pdptype" = "ip" -o "$pdptype" = "ipv4v6" ] && {
                cid_4=$(uqmi -s -d "$device" --get-client-id wds)
-               [ $? -ne 0 ] && {
+               if ! [ "$cid_4" -eq "$cid_4" ] 2> /dev/null; then
                        echo "Unable to obtain client ID"
                        proto_notify_error "$interface" NO_CID
                        return 1
-               }
+               fi
 
                uqmi -s -d "$device" --set-client-id wds,"$cid_4" --set-ip-family ipv4 > /dev/null
 
-               # try to clear previous autoconnect state
-               uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
-                       --stop-network 0xffffffff \
-                       --autoconnect > /dev/null
-
                pdh_4=$(uqmi -s -d "$device" --set-client-id wds,"$cid_4" \
                        --start-network \
                        ${apn:+--apn $apn} \
@@ -144,29 +157,35 @@ proto_qmi_setup() {
                        ${username:+--username $username} \
                        ${password:+--password $password} \
                        ${autoconnect:+--autoconnect})
-               [ $? -ne 0 ] && {
+
+        # pdh_4 is a numeric value on success
+               if ! [ "$pdh_4" -eq "$pdh_4" ] 2> /dev/null; then
                        echo "Unable to connect IPv4"
                        uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
                        proto_notify_error "$interface" CALL_FAILED
                        return 1
-               }
+               fi
+
+        # Check data connection state
+               connstat=$(uqmi -s -d "$device" --get-data-status)
+                [ "$connstat" == '"connected"' ] || {
+                        echo "No data link!"
+                        uqmi -s -d "$device" --set-client-id wds,"$cid_4" --release-client-id wds
+                        proto_notify_error "$interface" CALL_FAILED
+                        return 1
+                }
        }
 
        [ "$pdptype" = "ipv6" -o "$pdptype" = "ipv4v6" ] && {
                cid_6=$(uqmi -s -d "$device" --get-client-id wds)
-               [ $? -ne 0 ] && {
+               if ! [ "$cid_6" -eq "$cid_6" ] 2> /dev/null; then
                        echo "Unable to obtain client ID"
                        proto_notify_error "$interface" NO_CID
                        return 1
-               }
+               fi
 
                uqmi -s -d "$device" --set-client-id wds,"$cid_6" --set-ip-family ipv6 > /dev/null
 
-               # try to clear previous autoconnect state
-               uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
-                       --stop-network 0xffffffff \
-                       --autoconnect > /dev/null
-
                pdh_6=$(uqmi -s -d "$device" --set-client-id wds,"$cid_6" \
                        --start-network \
                        ${apn:+--apn $apn} \
@@ -175,12 +194,23 @@ proto_qmi_setup() {
                        ${username:+--username $username} \
                        ${password:+--password $password} \
                        ${autoconnect:+--autoconnect})
-               [ $? -ne 0 ] && {
+
+        # pdh_6 is a numeric value on success
+               if ! [ "$pdh_6" -eq "$pdh_6" ] 2> /dev/null; then
                        echo "Unable to connect IPv6"
                        uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
                        proto_notify_error "$interface" CALL_FAILED
                        return 1
-               }
+               fi
+
+        # Check data connection state
+               connstat=$(uqmi -s -d "$device" --get-data-status)
+                [ "$connstat" == '"connected"' ] || {
+                        echo "No data link!"
+                        uqmi -s -d "$device" --set-client-id wds,"$cid_6" --release-client-id wds
+                        proto_notify_error "$interface" CALL_FAILED
+                        return 1
+                }
        }
 
        echo "Setting up $ifname"
@@ -223,6 +253,7 @@ proto_qmi_setup() {
                        json_add_string name "${interface}_6"
                        json_add_string ifname "@$interface"
                        json_add_string proto "dhcpv6"
+                       [ -n "$ip6table" ] && json_add_string ip6table "$ip6table"
                        proto_add_dynamic_defaults
                        # RFC 7278: Extend an IPv6 /64 Prefix to LAN
                        json_add_string extendprefix 1
@@ -236,6 +267,7 @@ proto_qmi_setup() {
                json_add_string name "${interface}_4"
                json_add_string ifname "@$interface"
                json_add_string proto "dhcp"
+               [ -n "$ip4table" ] && json_add_string ip4table "$ip4table"
                proto_add_dynamic_defaults
                json_close_object
                ubus call network add_dynamic "$(json_dump)"
@@ -250,10 +282,15 @@ qmi_wds_stop() {
 
        uqmi -s -d "$device" --set-client-id wds,"$cid" \
                --stop-network 0xffffffff \
-               --autoconnect > /dev/null
+               --autoconnect > /dev/null 2>&1
 
-       [ -n "$pdh" ] && uqmi -s -d "$device" --set-client-id wds,"$cid" --stop-network "$pdh"
-       uqmi -s -d "$device" --set-client-id wds,"$cid" --release-client-id wds
+       [ -n "$pdh" ] && {
+               uqmi -s -d "$device" --set-client-id wds,"$cid" \
+                       --stop-network "$pdh" > /dev/null 2>&1
+       }
+
+       uqmi -s -d "$device" --set-client-id wds,"$cid" \
+               --release-client-id wds > /dev/null 2>&1
 }
 
 proto_qmi_teardown() {